//
//  Copyright: (C) 2006 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: ProgressDeterminator.h 28 2008-10-18 13:55:13Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>

@protocol ProgressCallbackDelegate
- (void)progessChanged:(NSNumber *)currentProgress;
@end

@interface ProgressDeterminator : NSObject 
{
  id <ProgressCallbackDelegate> _delegate;

  BOOL _shallContinue;
  NSLock *_shallContinueLock;
}

#pragma mark Initializer

- (id)initWithDelegate:(id <ProgressCallbackDelegate>)theDelegate;

#pragma mark Starting and Stopping

- (void)startMonitoring;

- (void)stopMonitoring;

#pragma mark Implemented by subclasses

- (NSNumber *)determineProgress;

@end
