//
//  Copyright: (C) 2005-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: CommandLineUtility.h 27 2008-10-10 19:15:29Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>

@class TaskCenter;
extern TaskCenter *taskCenterSingletonInstance;

@interface TaskCenter : NSObject
{
  NSMutableArray *_tasks;
}

#pragma mark Class Methods

+ (TaskCenter *)sharedTaskCenter;

#pragma mark Instance Methods

- (NSTask *)newTask;

- (void)terminateAllTasks;

- (void)applicationWillTerminate:(NSNotification *)notification;

- (void)taskWillTerminate:(NSNotification *)notification;

@end

NSTask *launchUtil(NSString *launchPath, NSArray *arguments, NSPipe *pipe);

NSData *NSDataFromCompleteStdoutByLaunchingUtil(NSString *launchPath, NSArray *arguments);
NSString *NSStringFromCompleteStdoutByLaunchingUtil(NSString *launchPath, NSArray *arguments);

id plistFromLaunchingAppleUtil(NSString *launchPath, NSArray *arguments);
