//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: CdrdaoFrontend(WriteCD).h 81 2008-03-24 20:46:10Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "CdrdaoFrontend.h"

@interface CdrdaoFrontend (WriteCD)

#pragma mark Writing CD

+ (NSTask *)writeToDRDevice:(DRDevice *)device
                    tocPath:(NSString *)tocPath
   bufferUnderrunProtection:(BOOL)bufferUnderrunProtection
                 numBuffers:(int)numBuffers
            leaveAppendable:(BOOL)leaveAppendable
                   simulate:(BOOL)simulate
                      speed:(int)speedAsTimes
                   delegate:(id <DiscOperationProgressDelegate>)delegate;

#pragma mark Internal Helpers for launching write

+ (NSTask *)writeToScsiLibDevice:(NSString *)device
                         tocPath:(NSString *)tocPath
        bufferUnderrunProtection:(BOOL)bufferUnderrunProtection
                      numBuffers:(int)numBuffers
                 leaveAppendable:(BOOL)leaveAppendable
                        simulate:(BOOL)simulate
                           speed:(int)speedAsTimes
                  standardOutput:(NSPipe *)pipe;


+ (NSTask *)writeToDRDevice:(DRDevice *)device
                    tocPath:(NSString *)tocPath
   bufferUnderrunProtection:(BOOL)bufferUnderrunProtection
                 numBuffers:(int)numBuffers
            leaveAppendable:(BOOL)leaveAppendable
                   simulate:(BOOL)simulate
                      speed:(int)speedAsTimes
             standardOutput:(NSPipe *)pipe;

#pragma mark Internal Helper for interpreting output from write

// threaded wrapper around below method
+ (void)threadedProcessWriteStandardOutput:(NSArray *)arguments;

+ (NSMutableDictionary *)processWriteStandardOutput:(NSPipe *)pipe
                                           delegate:(id <DiscOperationProgressDelegate>)delegate;

+ (DiscOperationState)scanWriteOutputLine:(NSString *)outputLine
                        augmentDictionary:(NSMutableDictionary *)dictionary
                         currentMegaBytes:(int *)currentMB
                           totalMegaBytes:(int *)totalMB;

+ (NSString *)scanForErrorInWriteOutputLine:(NSString *)outputLine;



@end
