//
//  Copyright: (C) 2006-2007 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: CdrdaoFrontend.h 105 2008-10-10 19:50:17Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import <DiscRecording/DiscRecording.h>
#import "DiscReader.h"
#import <MKFoundation/MKFoundation.h>

extern NSString *CDRDAO_PATH; // path to bundled binary
extern NSString *TOC2CUE_PATH; // path to bundled binary

#pragma mark Errors

//   occurs if wrong nonexistant device given (f.ex. IODVDServices/9)
extern NSString *CdrdaoError_NoMatchingDeviceFound;
//   occurs f.ex. if device exists, but disk not present
extern NSString *CdrdaoError_CannotSetupDevice;
//   occurs if disk is empty 
extern NSString *CdrdaoError_DiskIsEmpty;

extern NSString *CdrdaoError_CannotGetDiskInformation;

//   occurs if the toc file is already existant
extern NSString *CdrdaoError_TocFileAlreadyExists;

//   occurs if the toc file cannot be opened for writing
extern NSString *CdrdaoError_CannotOpenTocFile;

//   occurs if the drive does not support sub-channel reading
extern NSString *CdrdaoError_DriveDoesNotSupportSubChannelReading;

//   occurs if the bin file cannot be opened for writing
extern NSString *CdrdaoError_CannotOpenBinFile;

//   occurs if an error occurs while writing the bin file
extern NSString *CdrdaoError_WritingBinFileFailed;

//   occurs when one brutally remove an usb stick where the bin/toc should be written
extern NSString *CdrdaoError_WritingDataFailed;

//   occurs if an error occurs while reading the disk 
//   because it has an incompatible format
extern NSString *CdrdaoError_CannotReadMediumIncompatibleFormat;

@interface CdrdaoFrontend : NSObject
{
  NSDictionary *_membersOfCategories;
}

@end

#import "CdrdaoFrontend(DriveInfo).h"
#import "CdrdaoFrontend(ReadCD).h"
#import "CdrdaoFrontend(FixPathInToc).h"
#import "CdrdaoFrontend(Toc2Cue).h"
#import "CdrdaoFrontend(TocInfo).h"
#import "CdrdaoFrontend(WriteCD).h"
