//
//  Copyright: (C) 2005-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: WriteSpeedFormatter.h 118 2008-11-02 16:31:46Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import <SBRippingAndBurning/MediumClass.h>

@interface WriteSpeedFormatter : NSObject 
{
  id <MediumClassProvider> _mediumClassProvider; // unretained!
}

#pragma mark Class methods
+ (float)writeSpeedAsTimes:(float)value
               mediumClass:(SBMediumClass)mediumClass;

+ (NSString *)formatWriteSpeedAsString:(float)value 
                           mediumClass:(SBMediumClass)mediumClass;

#pragma mark Initializers
- (id)initWithMediumClassProvider:(id <MediumClassProvider>)provider;
@end
