//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: DiscOperationStatus.h 107 2008-10-18 18:26:23Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import <MKFoundation/MKFoundation.h>

typedef enum { DiscOperationState_Uninitialized,
               DiscOperationState_Started,
               DiscOperationState_Reading,
               DiscOperationState_Writing,
               DiscOperationState_TerminatedSuccessfully,
               DiscOperationState_TerminatedWithError } DiscOperationState;

#import "DiscOperationProgressDelegate.h"

@interface DiscOperationStatus : NSObject <DiscOperationProgressDelegate, ProgressCallbackDelegate>
{
  DiscOperationState _currentDiscOperationState, _previousDiscOperationState;
  NSNumber *_minValue, *_maxValue, *_currentValue;
  NSString *_shortText, *_longText;
  id <DiscOperationProgressDelegate> _delegate;
}

#pragma mark Initializers

- (id)initWithDelegate:(id <DiscOperationProgressDelegate>)theDelegate;

#pragma mark Getters

- (DiscOperationState)currentDiscOperationState;
- (DiscOperationState)previousDiscOperationState;
- (NSNumber *)minValue;
- (NSNumber *)maxValue;
- (NSNumber *)currentValue;
- (NSString *)shortText;
- (NSString *)longText;
- (id <DiscOperationProgressDelegate>)delegate;

#pragma mark Setters

- (void)setDiscOperationState:(DiscOperationState)theDiscOperationState;
- (void)setMinValue:(NSNumber *)theMinValue;
- (void)setMaxValue:(NSNumber *)theMaxValue;
- (void)setCurrentValue:(NSNumber *)theCurrentValue;
- (void)setShortText:(NSString *)theShortText;
- (void)setLongText:(NSString *)theLongText;
- (void)setDelegate:(id <DiscOperationProgressDelegate>)theDelegate;

@end
