//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: DiscReader.h 96 2008-06-23 18:50:28Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "DiscOperation.h"

@interface DiscReader : DiscOperation
{
  unsigned _sessionNumber;
  BOOL _shallRipRaw;
  unsigned _errorCorrectionLevel;
  NSString *_pathPrefix;

  NSLock *_readerTaskLock;
  NSTask *_readerTask;
}

#pragma mark Initializers

- (id)initWithDRDevice:(DRDevice *)device
         sessionNumber:(unsigned)sessionNumber
           shallRipRaw:(BOOL)ripRaw
  errorCorrectionLevel:(unsigned)errorCorrectionLevel
            pathPrefix:(NSString *)pathPrefix
              delegate:(id <DiscOperationProgressDelegate>)delegate;

#pragma mark Internal methods

- (void)threadedCDStart;
- (void)threadedDVDStart;

@end
