//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: DiscWriter.h 107 2008-10-18 18:26:23Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "DiscOperation.h"

@interface DiscWriter : DiscOperation
{
  NSString *_tocPath;
  BOOL _bufferUnderrunProtection, _leaveAppendable, _simulate;
  int _speedAsTimes;

  NSLock *_writerTaskLock;
  NSTask *_writerTask;
}

#pragma mark Initializers

- (id)initWithDRDevice:(DRDevice *)theDevice
               tocPath:(NSString *)tocPath
bufferUnderrunProtection:(BOOL)bufferUnderrunProtection
       leaveAppendable:(BOOL)leaveAppendable
              simulate:(BOOL)simulate
                 speed:(int)times
              delegate:(id <DiscOperationProgressDelegate>)theDelegate;

#pragma mark Internal methods

- (void)threadedCDStart;

@end
