//
//  Copyright: (C) 2005-2006 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: HdiUtilFrontend.h 1 2006-03-11 16:39:07Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>

extern NSString *HDI_UTIL_PATH;

@interface HdiUtilFrontend : NSObject
{
}

#pragma mark Convert the Stdio of the hdiutil cmd-line util into an object model

+ (NSMutableDictionary *)parsePListForImageAtPath:(NSString *)imagePath;

#pragma mark Convenience Accessors For The PropertyList

+ (unsigned long long)totalBytesForPList:(NSDictionary *)propertyList;
+ (NSString *)formatDescriptionForPList:(NSDictionary *)propertyList;

/*
 * returns array of NSMutableDictionaries with keys "filesystemType" and "name"
 */
+ (NSMutableArray *)partitionsForPList:(NSDictionary *)propertyList;

#pragma mark Mounting / Unmounting

+ (NSMutableDictionary *)parsePListAttachingImageAtPath:(NSString *)imagePath;
+ (BOOL)detach:(NSString *)deviceOrMountpoint;

@end

#import "HdiUtilFrontend(ReadDVD).h"
