//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: TrackInfo.h 88 2008-05-25 14:43:15Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//


#import <Cocoa/Cocoa.h>

@interface TrackInfo : NSObject 
{
  unsigned _trackNumber, _sessionNumber;
  uint64_t _blockSize;
  uint64_t _lengthInBytes;
  unsigned _blockType;
}

#pragma mark Factory Class Methods
// drTrackInfo is one of the value objects in the dictionary 
// obtained by DRDeviceTrackInfoKey
+ (id)trackInfoWithDRTrackInfo:(NSDictionary *)drTrackInfo;

#pragma mark Initializers
- (id)initWithDRTrackInfo:(NSDictionary *)drTrackInfo;

#pragma mark Getters
- (unsigned)trackNumber;
- (unsigned)sessionNumber;
- (uint64_t)blockSize;
- (uint64_t)lengthInBytes;
- (unsigned)blockType;

#pragma mark Derived Getters

- (NSString *)describeBlockType;
- (NSString *)describeLength;

- (BOOL)isAudioOrRawType;
- (BOOL)isDataType;

@end
