//
//  Copyright: (C) 2006 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: CdrdaoFrontend(DriveInfo).h 7 2006-04-10 00:46:30Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "CdrdaoFrontend.h"

// keys into dictionary returned for driveInfoFromDevice:
extern NSString *CdrdaoDriveInfo_ScsiLibDeviceNameKey;
extern NSString *CdrdaoDriveInfo_DisplayNameKey;
extern NSString *CdrdaoDriveInfo_DriverKey;
extern NSString *CdrdaoDriveInfo_MaximumReadingSpeedKey;
extern NSString *CdrdaoDriveInfo_CurrentReadingSpeedKey;
extern NSString *CdrdaoDriveInfo_MaximumWritingSpeedKey;
extern NSString *CdrdaoDriveInfo_CurrentWritingSpeedKey;
extern NSString *CdrdaoDriveInfo_BurnProofSupportedKey;
extern NSString *CdrdaoDriveInfo_JustLinkSupportedKey;
extern NSString *CdrdaoDriveInfo_JustSpeedSupportedKey;

@interface CdrdaoFrontend (DriveInfo)

#pragma mark Drive Info

+ (NSDictionary *)driveInfoFromScsiLibDevice:(NSString *)device;

// device is unlocked, and the above method is called with the corresponding scsilib device name
+ (NSDictionary *)driveInfoFromDRDevice:(DRDevice *)device;

#pragma mark Internal Helper for interpreting output from drive-info

+ (void)scanUsingScanner:(NSScanner *)scanner
      fromExcludedString:(NSString *)fromString
     untilExcludedString:(NSString *)untilString 
              intoString:(NSString **)intoString;

+ (void)scanUsingScanner:(NSScanner *)scanner
      fromExcludedString:(NSString *)fromString
     untilExcludedString:(NSString *)untilString 
          intoDictionary:(NSDictionary *)intoDictionary
                usingKey:(NSString *)key;
 
@end
