//
//  Copyright: (C) 2006 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: CdrdaoFrontend(TocInfo).h 15 2006-07-07 00:26:22Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "CdrdaoFrontend.h"

// keys into dictionary returned for driveInfoFromDevice:
extern NSString *CdrdaoTocInfo_NumTracksKey;
extern NSString *CdrdaoTocInfo_DurationKey;
extern NSString *CdrdaoTocInfo_NumBlocksKey;
extern NSString *CdrdaoTocInfo_NumMegaBytesKey;

@interface CdrdaoFrontend (TocInfo)

+ (NSDictionary *)tocInfoForTocPath:(NSString *)path;
+ (NSDictionary *)tocInfoForStandardOutput:(NSPipe *)pipe;

#pragma mark Internal Helper for interpreting output from toc-info

+ (BOOL)scanTocInfoOutputLine:(NSString *)outputLine
            augmentDictionary:(NSMutableDictionary *)dictionary;

@end
