//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: DiscOperationProgressPanel.h 107 2008-10-18 18:26:23Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "DiscReader.h"
#import "DiscWriter.h"

@class DRDevice;

@interface DiscOperationProgressPanel : NSWindowController <DiscOperationProgressDelegate>
{
  IBOutlet NSWindow *_discOperationProgressWindow;

  IBOutlet NSImageView *_imageView;
  IBOutlet NSTextField *_descriptionTextField;
  IBOutlet NSTextField *_statusTextField;
  IBOutlet NSProgressIndicator *progressIndicator;
  
  BOOL _busy;
  BOOL _reading; // else writing
  DiscReader *_discReader;
  DiscWriter *_discWriter;
  
  id <DiscOperationProgressDelegate> _delegate;
  NSWindow *_modalForWindow;
}

#pragma mark Class Methods

// return an autoreleased instance
+ (DiscOperationProgressPanel *)progressPanel;

#pragma mark Sheet Starting Methods

- (void)beginReadCDProgressSheetForDRDevice:(DRDevice *)device
                              sessionNumber:(unsigned)sessionNumber
                                shallRipRaw:(BOOL)shallRipRaw
                       errorCorrectionLevel:(unsigned)errorCorrectionLevel
                                 pathPrefix:(NSString *)pathPrefix
                             modalForWindow:(NSWindow *)docWindow
                                   delegate:(id <DiscOperationProgressDelegate>)theDelegate;

- (void)beginWriteCDProgressSheetForDRDevice:(DRDevice *)device
                                     tocPath:(NSString *)tocPath
                    bufferUnderrunProtection:(BOOL)bufferUnderrunProtection
                             leaveAppendable:(BOOL)leaveAppendable
                                    simulate:(BOOL)simulate
                                       speed:(int)speedAsTimes
                              modalForWindow:(NSWindow *)docWindow
                                    delegate:(id <DiscOperationProgressDelegate>)theDelegate;

#pragma mark Actions

- (IBAction)stop:(id)sender;

#pragma mark Internal

- (void)stopAndReleaseWorkers;

- (id <DiscOperationProgressDelegate>)delegate;
- (void)setDelegate:(id <DiscOperationProgressDelegate>)theDelegate;

@end
