//
//  Copyright: (C) 2006 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: HdiUtilFrontend(ReadDVD).h 16 2006-07-07 23:21:09Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "HdiUtilFrontend.h"                              
#import <DiscRecording/DiscRecording.h>
#import "DiscReader.h"

extern NSString *HdiUtilError_CreateFailed;

@interface HdiUtilFrontend (ReadDVD)

#pragma mark Reading DVD

+ (NSTask *)readDiscFromDRDevice:(DRDevice *)device
                    dmgImagePath:(NSString *)path
                  standardOutput:(NSPipe *)pipe;

+ (NSTask *)readDiscFromDRDevice:(DRDevice *)device
                    dmgImagePath:(NSString *)path
                        delegate:(id <DiscOperationProgressDelegate>)delegate;

#pragma mark Reading DVD (synchronous), not terminatable

+ (NSDictionary *)synchReadDiscFromDRDevice:(DRDevice *)device
                               dmgImagePath:(NSString *)path
                                   delegate:(id <DiscOperationProgressDelegate>)delegate;

#pragma mark Internal Helpers for interpreting output from hdiutil

+ (NSMutableDictionary *)processReadDVDStandardOutput:(NSPipe *)pipe 
                                             delegate:(id <DiscOperationProgressDelegate>)delegate;

+ (DiscOperationState)scanReadDVDOutputLine:(NSString *)outputLine
                       augmentDictionary:(NSMutableDictionary *)dictionary
                              percentage:(NSNumber **)percentage;

+ (NSString *)scanForErrorInReadDVDOutputLine:(NSString *)outputLine;

@end
