//
//  Copyright: (C) 2006-2008 by Martin Koehler <mkoehler@users.berlios.de>
//  $Id: MediumInfo.h 88 2008-05-25 14:43:15Z martin $
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version
//

#import <Cocoa/Cocoa.h>
#import "MediumClass.h"
#import "SessionInfo.h"

@class DRDevice;

@interface MediumInfo : NSObject
{
  NSArray *_sessions; // Array containing SessionInfo objects
  SBMediumClass _mediumClass;
  BOOL _isAppendable;
  BOOL _isBlank;
  uint64_t _discUsageInBytes;
}

#pragma mark Class Methods

+ (id)mediumInfoForDRDevice:(DRDevice *)device;
+ (SBMediumClass)mediumClassOfDevice:(DRDevice *)device;

#pragma mark Initializer

- (id)initWithDRDevice:(DRDevice *)device;

#pragma mark Getters

- (NSArray *)sessions;
- (SBMediumClass)mediumClass;

- (BOOL)containsAudioOrRawTracks;
- (BOOL)containsDataTracks;

- (NSString *)describeDiscUsage;

@end
